<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_TransportRate ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_TransportRate extends AbstractStructArrayBase
{
    /**
     * The TransportRate
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_TransportRate[]
     */
    public $TransportRate;
    /**
     * Constructor method for ArrayOfJP_TransportRate
     * @uses ArrayOfJP_TransportRate::setTransportRate()
     * @param \StructType\JP_TransportRate[] $transportRate
     */
    public function __construct(array $transportRate = array())
    {
        $this
            ->setTransportRate($transportRate);
    }
    /**
     * Get TransportRate value
     * @return \StructType\JP_TransportRate[]|null
     */
    public function getTransportRate()
    {
        return $this->TransportRate;
    }
    /**
     * This method is responsible for validating the values passed to the setTransportRate method
     * This method is willingly generated in order to preserve the one-line inline validation within the setTransportRate method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateTransportRateForArrayConstraintsFromSetTransportRate(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfJP_TransportRateTransportRateItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_TransportRateTransportRateItem instanceof \StructType\JP_TransportRate) {
                $invalidValues[] = is_object($arrayOfJP_TransportRateTransportRateItem) ? get_class($arrayOfJP_TransportRateTransportRateItem) : sprintf('%s(%s)', gettype($arrayOfJP_TransportRateTransportRateItem), var_export($arrayOfJP_TransportRateTransportRateItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The TransportRate property can only contain items of type \StructType\JP_TransportRate, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set TransportRate value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_TransportRate[] $transportRate
     * @return \ArrayType\ArrayOfJP_TransportRate
     */
    public function setTransportRate(array $transportRate = array())
    {
        // validation for constraint: array
        if ('' !== ($transportRateArrayErrorMessage = self::validateTransportRateForArrayConstraintsFromSetTransportRate($transportRate))) {
            throw new \InvalidArgumentException($transportRateArrayErrorMessage, __LINE__);
        }
        $this->TransportRate = $transportRate;
        return $this;
    }
    /**
     * Add item to TransportRate value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_TransportRate $item
     * @return \ArrayType\ArrayOfJP_TransportRate
     */
    public function addToTransportRate(\StructType\JP_TransportRate $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_TransportRate) {
            throw new \InvalidArgumentException(sprintf('The TransportRate property can only contain items of type \StructType\JP_TransportRate, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->TransportRate[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_TransportRate|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_TransportRate|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_TransportRate|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_TransportRate|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_TransportRate|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string TransportRate
     */
    public function getAttributeName()
    {
        return 'TransportRate';
    }
}
